   median.bootstrap.conf.bandDifferentRanges_Matrix_Parallel <- function(x,stockObs,numLag=10,
                                           weiObs=rep(1,nrow(x)),
                                           ngrid=300,alpha=0.5,smoothMethod="C2",
                                           rangeObs.x=rangeObs.x,rangeObs.y=rangeObs.y,
                                           B=20,
                                           sizeTail=0.025,
                                           alpha.evalPoints=alpha.evalPoints,
                                           new.evalPoints.x=seq(rangeObs.x[1],rangeObs.x[2],length=ngrid),
                                           calc.ergo.distr=TRUE,
                                           obsNormalized=FALSE){
    
   library(expm)
    
    stock.B <- array(NA,c(ngrid,ngrid,B))
    median.B <- matrix(NA,ngrid,B)
    average.B <- matrix(NA,ngrid,B)
    ergoDistr.B <- matrix(NA,ngrid,B)
    evalPointsNorm.B <- matrix(NA,ngrid,B)
    ergoDistrNorm.B <- matrix(NA,ngrid,B)
  
    
    for(ii in 1:B){
          print(paste("Bootstrap number = ", ii))
          
          #Indices of observations resamples
          jjj <- sample(c(1:nrow(x)),replace=TRUE,prob=weiObs)
          #jjj <- sample(c(1:length(actObs)),replace=TRUE)
                   
          #Vectors of actual and future observations
          x.B <- x[jjj,]
          weiObs.B <- rep(1,dim(x)[1])
                                      
          #print("Covariance matrix of sampled variables")
          #cov.matrix.B[1,ii] <- cov.wt(cbind(futObs.B,actObs.B),wt=weiObs.B,method="ML")$cov[1,1]
          #cov.matrix.B[2,ii] <- cov.wt(cbind(futObs.B,actObs.B),wt=weiObs.B,method="ML")$cov[2,2]         
          #print(cov.matrix.B[,ii])
    
          #print("Average of actual and future observations sampled")
          #mean.obs.B[2,ii] <- weighted.mean(actObs.B,w=weiObs.B)
          #mean.obs.B[1,ii] <- weighted.mean(futObs.B,w=weiObs.B)
          #print(mean.obs.B)
                    
          #Variance-covariance matrix
          #S.B <-  cov(cbind(futObs.B,actObs.B))
          S.B <- stockObs$S
          #S.B <-  cov.wt(cbind(futObs.B,actObs.B),wt=weiObs.B)$cov
          
          #Estimate of kernel density by Gaussian kernel
          stock  <-  bivariateDensityKernelAdaptiveDifferentRanges_Matrix_Parallel(x=x.B,
                        ngrid=ngrid,rangeObs.x=rangeObs.x,rangeObs.y=rangeObs.y,alpha=alpha,smoothMethod="C2",
                        weightsObs=weiObs.B,
                        provide.lambda=TRUE,
                        provide.h=TRUE,
                        h.norm.x.pilot=stockObs$h.norm.x,
                        h.norm.marg.density=stockObs$h.norm.marg.density,
                        lambdas.provide=stockObs$lambdas,
                        new.evalPoints.x=new.evalPoints.x,figure=FALSE,
                        ergodicDistr=calc.ergo.distr)

         stock.B[,,ii] <- stock$stocKernel 
         
         median.B[,ii] <- stock$medianKernel
         average.B[,ii] <- stock$averageKernel
         
         ergoDistr.B[,ii] <- stock$ergoDistr
         ergoDistrNorm.B[,ii] <- stock$ergoDistrNorm
    }

    #Calculation of the confidence band at 2*sizeTail% for the median and the expected value
     lowConfBand.median <- matrix(NA,1,ngrid)
     highConfBand.median <- matrix(NA,1,ngrid)
     averageConfBand.median <- matrix(NA,1,ngrid)

     lowConfBand.average <- matrix(NA,1,ngrid)
     highConfBand.average <- matrix(NA,1,ngrid)
     averageConfBand.average <- matrix(NA,1,ngrid)
     
     for (i in 1:ngrid){
  
         sortEst.median <- sort(median.B[i,])
         sortEst.average <- sort(average.B[i,])
                  
         if(round(B*sizeTail)==0){
           
           lowConfBand.median[i] <-min(sortEst.median)
           averageConfBand.median[i] <- mean(sortEst.median)

           lowConfBand.average[i] <-min(sortEst.average)
           averageConfBand.average[i] <- mean(sortEst.average)
           
         }else{
         
           lowConfBand.median[i] <-sortEst.median[round(B*sizeTail)]
           averageConfBand.median[i] <- mean(sortEst.median)

           lowConfBand.average[i] <-sortEst.average[round(B*sizeTail)]
           averageConfBand.average[i] <- mean(sortEst.average)

         }
         if(round(B*(1-sizeTail))==0){
          highConfBand.median[i] <-0
          highConfBand.average[i] <-0
         }else{
         
          highConfBand.median[i] <-sortEst.median[round(B*(1-sizeTail))]
          highConfBand.average[i] <-sortEst.average[round(B*(1-sizeTail))]
         
         }
  
     }


     if (calc.ergo.distr==TRUE){
      #Calculation of the confidence band at 2*sizeTail% for the ergodic distribution
       lowConfBand.ergodic <- matrix(NA,1,ngrid)
       highConfBand.ergodic <- matrix(NA,1,ngrid)
       averageConfBand.ergodic <- matrix(NA,1,ngrid)
  
      for (i in 1:ngrid){
  
         sortEst.ergodic <- sort(ergoDistrNorm.B[i,])
  
         if(round(B*sizeTail)==0){
  
           lowConfBand.ergodic[i] <- min(sortEst.ergodic)
           averageConfBand.ergodic[i] <- mean(sortEst.ergodic)
  
         }else{
  
           lowConfBand.ergodic[i] <-sortEst.ergodic[round(B*sizeTail)]
           averageConfBand.ergodic[i] <- mean(sortEst.ergodic)
         }
         if(round(B*(1-sizeTail))==0){
          highConfBand.ergodic[i] <-0
         }else{
  
          highConfBand.ergodic[i] <-sortEst.ergodic[round(B*(1-sizeTail))]
  
         }
  
      }
     }else{
      highConfBand.ergodic <- NA
      lowConfBand.ergodic <- NA
      averageConfBand.ergodic <- NA
      
     }

     list(lowConfBand.median=lowConfBand.median,highConfBand.median=highConfBand.median,
       averageConfBand.median=averageConfBand.median,lowConfBand.ergodic=lowConfBand.ergodic,
       highConfBand.ergodic=highConfBand.ergodic,averageConfBand.ergodic=averageConfBand.ergodic,
       ergoDistrNorm.B=ergoDistrNorm.B,median.B=median.B,ergoDistr.B=ergoDistr.B,
       stock.B=stock.B,average.B=average.B,
       lowConfBand.average=lowConfBand.average,
       highConfBand.average=highConfBand.average,
       averageConfBand.average=averageConfBand.average
       )
}