numericalIntegration <- function(densityObs,gridObs,checkTail=TRUE){

#numericalIntegration(ergoDistr1,stockLogGDP$evalPoints)
#Input
#densityObs = marginal density
#gridObs = evaluation points
#Output
#average =  average of distribution
#fdensity = total density

numObs <- length(densityObs)

tic <- diff(gridObs)

average <- 0

fdensity <- 0

for(i in 2:numObs){

 average <- average + ((densityObs[i]+densityObs[i-1])*tic[i-1]/2)*(gridObs[i]+gridObs[i-1])/2

 fdensity <- fdensity + (densityObs[i]+densityObs[i-1])*tic[i-1]/2

}

#Pick the lower tail
if ((fdensity<1) & (checkTail==TRUE)){

  average <- average + ((densityObs[1])*tic[1]/2)*(2*gridObs[1]-tic[1])/2

  fdensity <- fdensity + (densityObs[1])*tic[1]/2
}

#Pick the upper tail
if ((fdensity<1) & (checkTail==TRUE)){

  average <- average + ((densityObs[numObs])*tic[numObs-1]/2)*(2*gridObs[numObs]+tic[numObs-1])/2

  fdensity <- fdensity + (densityObs[numObs])*tic[numObs-1]/2
}

list(average=average,fdensity=fdensity)

}












